#ifndef _CONNECTION_FACTORY_H
#define _CONNECTION_FACTORY_H

#include<string>
#include<backend/odbc.h>
#include"Connection.h"

//Forward references
class Connection;

/**
 * \date 02-24-2004
 *
 * \author
 * This a connection factory, its a singleton used to make connections.
 * It also initializes the otl library.  
 *
 */
class ConnectionFactory
{
private:
	ConnectionFactory()
	{
		otl_connect::otl_initialize();		
	}
public:
	/**
	* Makes a new connection and returns a new connection object.
	* \param username 
	* \param passwd 
	* \param dsnsource 
	* \return 
	*/
	Connection* makeConnection(std::string username,
									std::string passwd,
									std::string dsnsource)
	{	
		Connection* connection = new Connection(username,passwd,dsnsource);		
		return(connection);
	}
	
	static ConnectionFactory* getInstance()
	{
		if(connectionFactory == 0)
			connectionFactory = new ConnectionFactory();
		return(connectionFactory);
	}

	/**
	* Destroys the connection factory
	* \return 
	*/
	~ConnectionFactory()
	{}
private:
	/*
	 *	Stores the count of the connections.
	 * Used to keep a track of whether to initialize otl library.
	 */
	static ConnectionFactory *connectionFactory;

};

ConnectionFactory* ConnectionFactory::connectionFactory = 0;

#endif //_CONNECTION_FACTORY_H