#ifndef _CACHE_REGION_H
#define _CACHE_REGION_H

#include <SpatialIndex.h>
namespace cache
{

	//Forward References
	class ICacheEntry;
	class RemainderRegion;

	/*This class is basically stores the 
	reference to the IShape object , used only to calculate the
	remainder regions*/


	class CacheRegion
	{
	public :
		CacheRegion(ICacheEntry &cacheEntry);

		//Copy Constructor
		CacheRegion(const CacheRegion &cacheRegion);

		//operator = undefined.
		CacheRegion& operator =(const CacheRegion &cacheRegion);

		//Note never delete regionPtr 	
		virtual ~CacheRegion();

		bool operator < (CacheRegion& cacheRegion);

		double getLeftExtent();

		double getRightExtent();	

		friend RemainderRegion* fillGap(
				CacheRegion& leftRegion,
				CacheRegion& rightRegion,
				double levelOfDetail);
		friend bool compare(const CacheRegion& a, const CacheRegion& b);

	private:	
		double leftExtent;//Stores the left extent
		double rightExtent;//Stores the right extent
		//Stores the lower radius value
		double levelOfDetail;
	};

	extern bool compare (const CacheRegion& a, const CacheRegion& b);
}

#endif //_CACHE_REGION_H
