#ifndef _DB_FILE_PARSER_H
#define _DB_FILE_PARSER_H

#include <string>
#pragma warning(disable: 4786 4250 4503 4244)

#include <DOM/SAX2DOM/SAX2DOM.h>
#include <SAX/helpers/CatchErrorHandler.h>
#include <DOM/Utils/Stream.h>


namespace cache
{
	//Forward References
	class Schema;
	class DBConfigStore;

/*
 *	This class parses the data base file config file and
 *  and 
 * This class is used by the cache builder to backend
 * 1) makes the Connection object
 * 2) Schema object
 */
class DBFileParser
{
public:
	/**
	* Constructs a DBFileParser 
	* the parser also parses the configuration 
	* file
	* \param file 
	* \return 
	*/
	DBFileParser(std::string file);

	/**
	 * Returns the schema object
	 * \return 
	 */
	Schema* getSchema();

	std::string getUserName();

	std::string getPasswd();

	std::string getDSNSource();

	std::string getTableName();

	//DBConfigStore* parse();

	DBConfigStore* getConfigStore();

	virtual ~DBFileParser();


private:
//Methods
	void makeSchemaObject(DOM::Document<std::string>& document);

private:
	//Stores the configration filename
	std::string fileName;
	//Stores the schema object
	Schema* schema;		
	//Stores the name of the table
	std::string tableName;
	//Stores the data base configuration parameters
	DBConfigStore* dbConfigStore;
	//Stores the number of dimensions
	unsigned int numberOfDimensions;
};

}
#endif