#ifndef _I_CACHE_ENTRY_H
#define _I_CACHE_ENTRY_H
#include <Tools.h>

namespace cache
{

	//Forward References
	class Cache;
	class CacheIterator;
	class Mapper;

	/*
	*	Used only for experimental purposes as of now.
	*/

	class ICacheEntry
	{
	public:
		struct Data
		{	
			//Not defined
			Data()
			{
				data = new double[1];
				numberOfDimensions = 1;
			}

			Data(int numberOfDimensions)
			{
				data = new double[numberOfDimensions];
				this->numberOfDimensions = numberOfDimensions;
			}

			Data(int numberOfDimensions,const double * inputData)		
			{
				data = new double[numberOfDimensions];
				//Initializing the data values in the cacheEntry
				for(int i=0;i<numberOfDimensions;i++)
				{
					this->data[i] = inputData[i];
				}			
			}

			void setData(const double *d, const unsigned int length)		
			{					
				if(!(length == this->numberOfDimensions))
				{
					delete[] data;
					data = new double[length];
					this->numberOfDimensions = length;
				}
				for(unsigned int i=0;i<length;i++)				
					this->data[i] = d[i];

			} // if(length == this->numberOfDimensions)			

			~Data()
			{
				delete[] data;
			}

			double *data;
			unsigned int numberOfDimensions;
		};

		//Copy constructor
		//Note this does not assign the replacement value
		ICacheEntry(ICacheEntry& cacheEntry);

		const unsigned long getID();

		void setID(const unsigned long id);


		Tools::Geometry::IShape* getIShape();


		bool ifNew();

		void setNew(bool b);

	protected:
		//HAve to remove this	
		ICacheEntry();

	public:
		virtual ~ICacheEntry();

		//For testing purposes.
	public:
		//Stores the data Items
		Data *data;

		//Stores the descriptor of the CacheEntry
		Tools::Geometry::IShape* iShape;

		//Stores the Id of the cache Entry, this has to be a unique id
		unsigned long id;

		//Store if the Cache Entry contains a a new Data Item fetched
		//from the database
		bool isNew;

		//Used temporarily to give the values to the front end. Note the 
		//same information is also contained in IShape but coying this.
		double x;
		double y;
		double l;
		unsigned int n;

		//friend classes
		friend class Cache;	
		friend class Mapper;	
		friend class CacheIterator;
		
	};


}
#endif