#ifndef _PERFORMANCE_STATS_H
#define _PERFORMANCE_STATS_H
//This class is basically a central repository for performance statistics
//used stores the performance statistics for every call to load.
//This class does not contain any calculated statistics. They are just
//performance characteristics for a call to load.
namespace cache
{
	class PerformanceStatistics
	{
	public:
		/*
		*	Creates a new class
		*/
		PerformanceStatistics()
		{
			this->numberOfHits = 0;
			this->searchLatency = 0;
			this->brushSize = 0;
			this->totalFragments = 0;
			this->queryExecution = 0;
		
		}

		PerformanceStatistics(PerformanceStatistics& perStatistics)
		{
			this->numberOfHits = perStatistics.numberOfHits;
			this->searchLatency = perStatistics.searchLatency;
			this->totalFragments = perStatistics.totalFragments;
			this->queryExecution = perStatistics.queryExecution;
			this->brushSize = perStatistics.brushSize;
		}

		//Stores the number of hits
		unsigned int numberOfHits;
		//Stores the current search latency
		unsigned long searchLatency;
		//Stores the total number of fragments in the cache.
		unsigned int totalFragments;
		//Stores the time it takes to execute the query
		unsigned int queryExecution;
		//Stores the size of the current brush
		unsigned long brushSize;
	};
}

#endif //__PERFORMANCE_STATS_H
