#ifndef _RECORD_H
#define _RECORD_H

namespace cache
{

	struct Record{

		/**
		* constructs a Record
		* \param size 
		* \return 
		*/
		Record(const unsigned int size)
		{
			this->e1 = -1.;
			this->e2 = -1.;
			this->radius = -1.;
			this->parent_radius = -1;
			this->D = new double[size];
			this->size = size;
			for (unsigned int index=1; index<size; index++)
				this->D[index] = 0.;
		}

		/* cluster's extents and level	*/
		double	e1,					// Left  extent
			e2,					// Right extent
			radius,				// Level extent
			parent_radius;

		int	N;					// # of datapoints or leaf nodes in cluster.

		double    *D;	// dim. aggregate values
		int size;

		~Record()
		{
			delete[] D;
		}
	};
}
#endif //_RECORD_H

