#ifndef __METAFACTORY_H__
#define __METAFACTORY_H__

#include <meta/Interfaces.h>

class MetaFactory
{
public:
	IMeta*		createMeta();

	IMeta*		getMeta() const;
	
	static MetaFactory* instance() {
		if (!factory) {
			factory = new MetaFactory;
		}
		return factory;
	}

	~MetaFactory() { if (meta) { delete meta; } }
	
private:
	// make these private so that MetaFactory is a singleton
	MetaFactory() { meta = 0; }
	MetaFactory(const MetaFactory& f) {}
	MetaFactory& operator = (const MetaFactory& f) { return *this; }
	
	// the only instance of MetaFactory
	static MetaFactory* factory;
	// the only instance of IMeta to be returned everytime
	IMeta* meta;
};

#endif //__METAFACTORY_H__
