// MetaHelper.h
//
//////////////////////////////////////////////////////////////////////

#pragma warning(disable:4786)

#ifndef __METAHELPER_H__
#define __METAHELPER_H__

#include <string>
#include <stack>
#include <SAX/XMLReader.h>
#include <SAX/helpers/DefaultHandler.h>

struct MetaHelper
{
	static MetaHelper* instance() {
		if (!global) {
			global = new MetaHelper;
		}
		return global;
	}

	static void reinitialize();

	void pushHandler(SAX::ContentHandler *handler);
	SAX::ContentHandler* popHandler();

	SAX::XMLReader<std::string>& getParser();

private:
	MetaHelper();
	MetaHelper(const MetaHelper&) {}
	MetaHelper& operator = (const MetaHelper&) {}

	SAX::XMLReader<std::string> parser;
	std::stack<SAX::ContentHandler*> contentHandlers;

	static MetaHelper* global;
};

#define METAHELPER MetaHelper::instance()

#endif //__METAHELPER_H__
