// URI.h: interface for the URI class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __URI_H__
#define __URI_H__

#include "BasicTypes.h"

class URI : public BasicTypeValue
{
public:
	URI(const char *str) 
	{ initialize(str); }
	URI(const URI& iv);
	
	static Type getTypeId() {
		if ( mTypeId.isBad() ) {
			mTypeId = Type::registerType(
				BasicTypeValue::getTypeId(),"uri",
				createURIValue);
		}
		return mTypeId;
	}
	
	static Value* createURIValue(const char* str, void*) 
	{ return new URI(str); }
	
	Type getType() const { return String::getTypeId(); }
	Value* clone() const { return new URI(*this); }
	std::string	toString() const
	{	return "";		}
	
private:
	void initialize(const std::string& str);
	
    std::string     mScheme;
    std::string     mUserInfo;
    std::string     mHost;
    int             mPort;
    std::string     mPath;
    std::string     mQueryString;
    std::string     mFragment;
    std::string     mURIText;
	static Type		mTypeId;
	
};

#endif //__URI_H__
