#ifndef CFlatGlyph_H
#define CFlatGlyph_H

#include <xmdv/CFlatDisplay.h>
#include <xmdv/Vec2.h>

class CFlatGlyph : public CFlatDisplay 
{
private: 
    ARR<Vec2> poly;
    ARR<double> norm;
public:
	CFlatGlyph(CFlatDisplayInformation* flat_info);
    virtual ~CFlatGlyph();

    void SetParameters();
    //draw single data
    void DrawSingleData(ARR<double> REF data, int datano);
    void DrawSingleDataWithTwoAxes(ARR<double> mean, ARR<double> max, ARR<double> min, int datano, bool unbrushed);
    void DrawOthers();
	void ClutterBasedOrder( );		// added by debbie 9/2003

    //event handlers
    void InputMouseMotion(int x, int y);
    void InputButtonPress(int button, int x, int y);
    void InputButtonRelease(int button, int x, int y);

    static void InputGlyphMouseMotion(struct grCanvas *canvas, int x, int y);
    void InputGlyphBrushSelect(grCanvas *canvas, int sx, int sy);
    void InputGlyphButtonPress(grCanvas *canvas, int button, int x, int y);

protected:
    //set color and style for unbrushed data
    void SetUnbrushedColorAndStyle();
//    void SetAverageColorAndStyle();
    void RedrawSingleGlyph(grCanvas *canvas, int glyphno);

    
};


#endif



