#ifndef ORDERDIMENSION_H
#define ORDERDIMENSION_H

typedef struct {
	grCanvas *canvas;
	int algorithm;
	int min_max;
	int brushed;
	int correlation;
	double threshold_1;
	double threshold_2;
	int nn_start_dim;
	int eight_connected;
	//Added by Zaixian
	Tcl_Interp *interp;
} Reorder_Parameters;

double calc_scale( double , double **, int , int );


double simi_func(double **, int , int , int, int );



double sim_total(double **similarity_matrix, int dim_num, ARR<int> array);

void swap_element(ARR<int> &, int , int );


void recur_order(double **, int , ARR<int> &, ARR<int> &, int, int, int );



void nearest_neighbor(double **, int , ARR<int> &, int, int, int );


void greedy_algorithm(double **, int dim, ARR<int> &, int, int);


double find_smallest_pair(double **, int, double, int &, int &, bool **);


double find_largest_pair(double **, int, double, int &, int &, bool **);


double find_max_distance(double **, int);

bool in_same_group(int **, int, int, int);

bool similarity_reorder(int, int, double **, ARR<int> &, Reorder_Parameters);

double clutter_measure_symmetry(double **norm_matrix, int data_num, int dim_num, ARR<int> array, double, double);

void clutterbased_reorder_glyph(int, int, double **, ARR<int> &, Reorder_Parameters);

void clutterbased_reorder_dimstck(int, int, double ** , ARR<int> &, Reorder_Parameters);

void clutterbased_reorder_parcord(int, int, double **, ARR<int> &, Reorder_Parameters);

void clutterbased_reorder_scatterplot(int, int, double **, ARR<int> &, Reorder_Parameters);

double Total_Outlier_Number(double **outlier_matrix, int dim_num, ARR<int> array);

double Total_Separation(double **sim_matrix, int used_dim, ARR<int> order, double threshold);

ARR<Vec2> Calc_Dimstck_Pos(const ARR<double> &size, double ** data_matrix, int set_size, int dim_num, ARR<int> order_array);
double isolated_ratio(ARR<Vec2> DimStckData, int set_size, double &group_ratio, double threshold, int neighbor_def);
int Outlier_Between(double **norm_matrix, int data_num, int dim_1, int dim_2, double threshold);

bool similarity_reorder_interring(int n, int m, double **data_matrix, ARR<int> &order_array, int choice, int correlation, char * sim_or_dis, int nn_start_dim); 

#endif
