///////////////////////////////////////////////////////////////////////////////
/// \file PixelTool.h
/// \brief Declaration of the CPixelTool class
/// \date 7/5/2004
/// \author anilkpatro
///////////////////////////////////////////////////////////////////////////////

#ifndef _PIXELTOOL_H
#define _PIXELTOOL_H

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//
#include <xmdv/CFlatPixel.h>

// DEFINES
//

// FORWARD REFERENCES
//
class CFlatDisplayInformation;

///
/// <Brief Description>
///
/// USAGE:
/// <pre>
/// 	<Example usage of the class>
/// </pre>
/// \date 7/5/2004
/// \author anilkpatro
///
class CPixelTool : public CFlatPixel
{
public:		// methods

// LIFECYCLE
//
	///
	/// Constructor
	/// 
	CPixelTool(CFlatDisplayInformation *flat_info);

	/// 
	/// Destructor
	/// 
	~CPixelTool();

// OPERATORS
//

	/// 
	/// Assignment operator
	/// 
	/// \param from the value to assign to this object
	/// \return reference to this object
	CPixelTool	&operator =(const CPixelTool &from);

// OPERATIONS
//
	void		Draw();

	//event handlers
	void		InputMouseMotion(int x, int y);
	void		InputButtonPress(int button, int x, int y);
	void		InputButtonRelease(int button, int x, int y);

private:	// members

	friend struct Marker;
	struct Marker
	{
		MarkerStatus	status;
		float			x1, y1, x2, y2;
		int				dim;

		Marker(int d)
		{
			status = MST_BLANK;
			x1,y1,x2,y2 = 0;
			dim = d;
		}
		void setExtents(float X1, float Y1, float X2, float Y2)
		{
			x1 = X1; y1 = Y1; x2 = X2; y2 = Y2;
		}
		MarkerStatus contains(float x, float y);
	};
	typedef std::vector<Marker>	Markers;
	Markers						m_markers;
};

// INLINE METHODS
//

#endif	// _PIXELTOOL_H
