/* file: pfTimer.cpp 
 * purpose: define prefetching timer class
 * revision log:
 */

#include <Timer/Timer.h>
#include <stdio.h>


Timer :: Timer()
{}


/**
 * Ends the timer and returns
 * the difference between the start and the 
 * the stop times in msec granularity
 * Note: For win32 we can also get at the level of microseconds. But we are 
 * dividing by 1000 to keep the interface uniform.
 * \return 
 */
unsigned long Timer :: endTimer()
{
	unsigned long total_op_time = 0 ;

#ifndef _WIN32
	time_t end_op_time;
	time(&end_op_time);
	total_op_time += difftime(end_op_time,this->start_op_time);
#else
	oPreciseTimer.StopTimer();	
	__int64 i64Diff = oPreciseTimer.GetTime();	
	total_op_time = (unsigned long) (i64Diff/1000);	
#endif
	return total_op_time ;	
}

/*
 *	Starts the timer
 */
void Timer :: startTimer(void) 
{ 		
		#ifndef _WIN32
			time(&(this->start_op_time));			
		#else
			oPreciseTimer.StartTimer();		
		#endif	
}
	

/**
 * Used to test the timer
 */
unsigned long Timer ::test()
{
	printf("Testing pfTimer class -- begin\n") ;

	this->startTimer();
	for (int i=0 ; i < 10000000; i++);	
	return(this->endTimer());
}



