#include <DataIterator.h>
#include <CacheIterator.h>
#include <CacheController.h>

using namespace cache;

/*
* The main purpose of using the Data Iterator is the 
* the cache controller can be notified of the end load event.
* This event when the prefetcher has to start.
*/

DataIterator::DataIterator(CacheIterator* cacheIterator,
						   CacheController* controller): 
									cacheController(controller),
									cacheIterator(cacheIterator)

{}	

ICacheEntry* DataIterator :: get_next()
{
	return(this->cacheIterator->get_next());
}


bool DataIterator :: isDone()
{
	return(this->cacheIterator->isDone());
}

DataIterator :: ~DataIterator()
{
	this->cacheController->endLoad();
	delete(this->cacheIterator);
}

