#include<Mapper.h>
#include <stdio.h>
#include<ICacheEntry.h>
#include<Record.h>

using namespace cache;
//Defining a mapper
Mapper* Mapper::mapper = NULL;

Mapper* Mapper::getInstance()
{
	if(mapper == NULL)
		mapper = new Mapper();

	return(mapper);
}

Mapper :: Mapper()
{}	


Mapper :: ~Mapper()
{}

void Mapper::initialize(ICacheEntry& cacheEntry,
				Record& record)	
{

	cacheEntry.data->setData(record.D,record.size);		

	if(cacheEntry.iShape != NULL)		
		delete(cacheEntry.iShape);

	//Initializing the shape
	double low[2];
	double high[2];

	low[0] = record.e1;
	low[1] = record.radius;
	high[0] = record.e2;
	high[1] = record.parent_radius;
	if(high[0] == 1.00)
	{
		printf("Break");
	}
	Tools::Geometry::Region *region = new Tools::Geometry::Region(low,high,2);

	cacheEntry.iShape =  region;
	cacheEntry.isNew = true;
	//Note assigned to serve the front end. Don't need other wise
	cacheEntry.x = record.e1;
	cacheEntry.y = record.e2;
	cacheEntry.l = record.radius;
	cacheEntry.n = record.N;
}	

