/*
*	The main objective of this class is to reduce the coupling
* between the PrefetchController and the Prefetcher
* Don't have any good reason to make this class
*/
#include <cache/LoadRequester.h>
#include <cache/Brush.h>
#include <cache/CacheIterator.h>
#include <cache/CacheManager.h>
#include <PrefetchController.h>
#include <cache/PerformanceStatistics.h>
#include <cache/QueryFactory.h>

using namespace cache;
//Defining the static member
LoadRequester* LoadRequester::loadRequester;

LoadRequester::LoadRequester(CacheManager* cacheManager,
							 PrefetchController* prefetchController)
{
	this->cacheManager= cacheManager;
	this->prefetchController = prefetchController;
}
/*
 *	If the prefetcher is executing the query you do not want to
 *  to execute the query, because no point in clearing the cache
 *  for a guessed query. That is why returns false and that forces the load
 *  method to return the cache iterator with 0 tuples.
 */
bool LoadRequester::exceededFragThreshold()
{
	return(false);
}


LoadRequester* LoadRequester:: getInstance()
{	
	return(loadRequester);
}

void LoadRequester :: make(CacheManager* cacheManager,
						   PrefetchController* prefetchController)
{
	loadRequester = new LoadRequester(cacheManager,prefetchController);
}


CacheIterator* LoadRequester :: load(Brush* brush,
									 AbstractRegionFactory *regionFactory,
									 PerformanceStatistics& perStatistics,
									 QueryModifier& queryModifier)
{
	return(this->cacheManager->load(*brush,								 
		(IReplacementVisitor*) this->prefetchController,
		this,
		regionFactory,
		perStatistics,
		queryModifier));
}


